//+------------------------------------------------------------------+
//|                                           market order ecnv1.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
//-----------------------------------------------------------------------------+
// External Variables

extern bool   DynamicLotSize = true;
extern double EquityPercent  =   2;
extern double FixedLotSize   = 0.01;
extern double StopLoss       =  90;
extern double TakeProfit     =   5;
extern double TrailingStop   =   0;
extern int    MinimumProfit  =   0;
extern double BreakEven      =   0;
extern double ProfitMin      =   0;
extern int    Slippage       =   5;
extern double Distance       =   2;
extern int    MinLimit       =   3;
extern int    MagicNumber    = 123456;

//-----------------------------------------------------------------------------+
// Global Variables

int    Ticket,total,OpenOpposite=1;
double PipsProfit,LotSize,OpenPrice,Price,pt;
double StopLevel,UpperStopLevel,LowerStopLevel,MinStop;

//-----------------------------------------------------------------------------+
int init()
	  {
	   if (Digits ==3 || Digits ==5)pt=10*Point;
      else pt=Point;
      Slippage=Slippage*pt;	
     }
//-----------------------------------------------------------------------------+
void start()
 {
 if (OrdersTotal()==0)GoToOpen();
 else GoToClose();
 if(BreakEven>0)MoveBreakEven();
 if(TrailingStop>0)BuyTrailingStop();
 if(TrailingStop>0)SellTrailingStop();
 if(OpenOpposite>0)OpenOppositeOrder(); 
 }
 //+---------------------------------------------------------------------------+	

int GoToOpen()
{
  double Price= NormalizeDouble(OrderOpenPrice(),Digits);
  
  
//+---------------------------------------------------------------------------+          		
// Lot size calculation

        if(DynamicLotSize == true)
        {
         double RiskAmount = AccountEquity() * (EquityPercent / 100);
         double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
         if(Point == 0.001 || Point == 0.00001) TickValue *= 10;
         double LotSize = (RiskAmount / StopLoss) / TickValue;
        }
         else LotSize = FixedLotSize;
//+---------------------------------------------------------------------------+     
// Lot size verification

        if(LotSize < MarketInfo(Symbol(),MODE_MINLOT))
        {
         LotSize = MarketInfo(Symbol(),MODE_MINLOT);
        }
         else if(LotSize > MarketInfo(Symbol(),MODE_MAXLOT))
        {
         LotSize = MarketInfo(Symbol(),MODE_MAXLOT);
        }		
         if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
        {
         LotSize = NormalizeDouble(LotSize,1);
        }
         else LotSize = NormalizeDouble(LotSize,2);
	 	
//+----------------------------------------------------------------------------+		
// Buy Order Condition to Open

            if(Bid+Distance*pt>Price)             
	        {	
// Open buy order

			    while(IsTradeContextBusy()) Sleep(10);
				 RefreshRates();	
		
             Ticket=OrderSend(Symbol(),OP_BUY,LotSize,NormalizeDouble(Ask,Digits),Slippage,0,0,"Buy Order",MagicNumber,0,Green);
             if(Ticket>0)AddLimitsBuy();
            }
//-----------------------------------------------------------------------------+	
// Sell Order Condition to Open
            if(Bid-Distance*pt<Price)           
           {                                  
// Open Sell order	
			
			    while(IsTradeContextBusy()) Sleep(10);
				 RefreshRates();	
						
				 Ticket=OrderSend(Symbol(),OP_SELL,LotSize,NormalizeDouble(Bid,Digits),Slippage,0,0,"Sell Order",MagicNumber,0,Red);
				 if(Ticket>0)AddLimitsSell();
 				}					
 			 }	
//+---------------------------------------------------------------------------+
int GoToClose()
{
  if(GetProfit()>0)
  {
  CloseAll();
  }
}  
//+---------------------------------------------------------------------------+
double GetProfit()
{
     double Profit = 0;
     for (int Trades = OrdersTotal();Trades>=0; Trades--)
   {
     if (OrderSelect(Trades, SELECT_BY_POS, MODE_TRADES))
     Profit = Profit+OrderProfit()+OrderSwap()+OrderCommission();
   }
   return (Profit);
}
//+---------------------------------------------------------------------------+  
  void CloseAll()
{
   bool   Result;
   int    i,Op,Error;
   int    Total=OrdersTotal();
   
   if(Total>0)
   {
     for(i=Total-1; i>=0; i--) 
     {
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == TRUE) 
       {
         Op=OrderType();
         if(Op==OP_BUY)
         {
         Result=OrderClose(OrderTicket(),OrderLots(),Bid, Slippage, Yellow);
         }
         if(Op==OP_SELL)
         {
         Result=OrderClose(OrderTicket(),OrderLots(),Ask, Slippage, Yellow);
         }
         if(Result!=true) 
          { 
           Error=GetLastError(); 
           Print("LastError = ",Error); 
          }
         else Error=0;

       }   
     }
   }
   return(0);
}
//+---------------------------------------------------------------------------+  
	void MoveBreakEven()
{
 int cnt,total=OrdersTotal();
 for(cnt=0;cnt<total;cnt++)
{
 OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
 if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
 {
  if(OrderType()==OP_BUY)
  { 
   if(BreakEven>0)
  {
   if(NormalizeDouble((Bid-OrderOpenPrice()),Digits)>BreakEven *pt)
    {
     if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),Digits)<0)
     {
      OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+ProfitMin*pt,Digits),OrderTakeProfit(),0,Blue);
      
      return(0);
      }
     }
    }
   }
   else
    {
//+------------------------------------------------------------------+   
    if(BreakEven>0)
    {
     if(NormalizeDouble((OrderOpenPrice()-Ask),Digits)>BreakEven*pt)
     { 
      if (NormalizeDouble((OrderOpenPrice()- OrderStopLoss()),Digits)<0)
      {
       OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-ProfitMin*pt,Digits),OrderTakeProfit(),0,Blue);
       
       return(0);
       }
      }
     }
    }
   }
  }
 }
     
//+------------------------------------------------------------------+ 
  void BuyTrailingStop() 
   {   
    for(int Counter=0;Counter<=OrdersTotal()-1;Counter++)
   {
    OrderSelect(Counter,SELECT_BY_POS);
    
    double MaxStopLoss = MarketInfo(Symbol(),MODE_BID)-(TrailingStop*pt);
    double PipsProfit = MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice();
    double MinProfit = MinimumProfit*pt;
    if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderStopLoss()<MaxStopLoss && PipsProfit>=MinProfit)
   {
     OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);     
  }
 }
}
//+------------------------------------------------------------------+ 
 void SellTrailingStop()
  {
   for(int Counter=0;Counter<=OrdersTotal()-1;Counter++)
  {
   OrderSelect(Counter,SELECT_BY_POS);
   
   double MaxStopLoss = MarketInfo(Symbol(),MODE_ASK)+(TrailingStop*pt);
   double PipsProfit = OrderOpenPrice()- MarketInfo(Symbol(),MODE_ASK);
   double MinProfit = MinimumProfit*pt;
   if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()&& OrderType()==OP_SELL && OrderStopLoss()> MaxStopLoss && PipsProfit>=MinProfit)
  {
    OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);
  }
 }
}
//+------------------------------------------------------------------+ 
 double OpenOppositeOrder() 
 {
  int Op;  
 
  for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
  {
     OrderSelect(Ticket,SELECT_BY_TICKET);
   {
    if(OrderSymbol()==Symbol()&& OrderMagicNumber()==MagicNumber)
    {
     Op=OrderType();
     if(Op==OP_BUY && NormalizeDouble(Bid,Digits)<OrderOpenPrice())
     {      
     Ticket = OrderSend(Symbol(),OP_SELL,LotSize,NormalizeDouble(Bid,Digits),Slippage,0,0,"Sell Order",MagicNumber,0,Red);
     if(Ticket>0)AddLimitsSell();
      } 
      if( Ticket > 0 )
   {
   Print("Order placed # ", Ticket);
   }
else
   {
   Print("Order Send failed, error # ", GetLastError() );
   }
     if(Op==OP_SELL && NormalizeDouble(Ask,Digits)>OrderOpenPrice())
     {      
     Ticket = OrderSend(Symbol(),OP_BUY,LotSize,NormalizeDouble(Ask,Digits),Slippage,0,0,"Buy Order",MagicNumber,0,Green);
     if(Ticket>0)AddLimitsBuy();
      }
      if( Ticket > 0 )
   {
   Print("Order placed # ", Ticket);
   }
else
   {
   Print("Order Send failed, error # ", GetLastError() );
   }   
     }
    }
   }
  }
//+------------------------------------------------------------------+  
double AddLimitsBuy()
                 {
                  OrderSelect(Ticket,SELECT_BY_TICKET);
                   OpenPrice = OrderOpenPrice();

 StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
				       RefreshRates();	
				       UpperStopLevel = Ask + StopLevel;
				       LowerStopLevel = Bid - StopLevel;
				       MinStop        = MinLimit * pt;
				      
				      if(StopLoss > 0)   double BuyStopLoss   = OpenPrice - (StopLoss * pt);
                  if(TakeProfit > 0) double BuyTakeProfit = OpenPrice + (TakeProfit * pt);
				      
				      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel) 
					      {					
						    BuyStopLoss = LowerStopLevel - MinStop;
					      }
				      
				      if(BuyTakeProfit > 0 && BuyTakeProfit < UpperStopLevel) 
					      {
						     BuyTakeProfit = UpperStopLevel + MinStop;
					      }

				      if(IsTradeContextBusy())Sleep(10);	

                  if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
                     {		
                      OrderModify(Ticket,OpenPrice,BuyStopLoss,BuyTakeProfit,0);                            
                     }
                    } 
//+------------------------------------------------------------------+
double AddLimitsSell()
                 {
                  OrderSelect(Ticket,SELECT_BY_TICKET);
                  OpenPrice = OrderOpenPrice();
StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
				      RefreshRates();	
				      UpperStopLevel = Ask + StopLevel;
				      LowerStopLevel = Bid - StopLevel;
				      MinStop        = MinLimit *  pt;
				      if(StopLoss > 0) double SellStopLoss = OpenPrice + (StopLoss * pt);
				      if(TakeProfit > 0) double SellTakeProfit = OpenPrice - (TakeProfit *	pt);
				      
				      if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel) 
					      {					
						    SellStopLoss = UpperStopLevel + MinStop;
					      }
				      if(SellTakeProfit> 0 && SellTakeProfit > LowerStopLevel) 
					      {
						    SellTakeProfit = LowerStopLevel - MinStop;
					      }
				      if(IsTradeContextBusy()) Sleep(10);	

                  if(SellStopLoss > 0 || SellTakeProfit > 0) 
                    {		
                      OrderModify(Ticket,OpenPrice,SellStopLoss,SellTakeProfit,0);
                    }                    
                   }
//+------------------------------------------------------------------+ 